Bug 146141 - bug in netfs script causes hang on shutdown
bug in netfs script causes hang on shutdown
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: initscripts (Show other bugs)
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Bill Nottingham
Brock Organ
Depends On:
Blocks: 168995
  Show dependency treegraph
Reported: 2005-01-25 12:26 EST by Chris O'Regan
Modified: 2014-03-16 22:52 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2005-09-21 17:18:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Patch to fix NFS umount bug in /etc/init.d/netfs (2.14 KB, patch)
2005-01-25 12:29 EST, Chris O'Regan
no flags Details | Diff

  None (edit)
Description Chris O'Regan 2005-01-25 12:26:23 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.5)
Gecko/20041123 Firefox/1.0

Description of problem:
It appears that the netfs script was written with the intention to
gracefully stop (unmount) NFS file systems.  The problem is that the
first thing the script does is forcibly unmount the NFS-mounted file
systems.  As a result, it is unable to terminate any processes that
have files open on those file systems.  On our servers -- where we use
NFS extensively -- this leaves hundreds of processes "stuck" because
NFS was pulled out from under them, and the servers fail to shutdown
properly, usually requiring a power cycle.

We've patched the netfs script so that it gracefully stops all
processes with open files on NFS-mounted file systems.  It makes four
attempts (sending the following signals in this order: HUP, TERM,
KILL, KILL) before forcing the umount.  Test shows that it works as
expected, and our servers shutdown quickly.  I'll include the patch as
soon as I can figure out where to upload it.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. Start a process that opens a file on an NFS-mounted file system.
2. Shutdown system


Actual Results:  System hangs on shutdown.

Expected Results:  System should have shutdown quickly and not
required a power cycle.

Additional info:
Comment 1 Chris O'Regan 2005-01-25 12:29:54 EST
Created attachment 110205 [details]
Patch to fix NFS umount bug in /etc/init.d/netfs
Comment 2 Bill Nottingham 2005-09-21 17:18:51 EDT
This problem is being considered for the next release of Red Hat Enterprise
Linux. Red Hat does not currently plan to provide a resolution for this in a Red
Hat Enterprise Linux update for currently deployed systems.

With the goal of minimizing risk of change for deployed systems, and in response
to customer and partner requirements, Red Hat takes a conservative approach when
evaluating changes for inclusion in maintenance updates for currently deployed
products. The primary objectives of update releases are to enable new hardware
platform support and to resolve critical defects. 

Note You need to log in before you can comment on or make changes to this bug.